#!/bin/sh
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: © 2018 Antoine Le Gonidec <vv221@dotslashplay.it>
set -o errexit

###
# Graveyard Keeper
# send your bug reports to contact@dotslashplay.it
###

script_version=20221228.1

# Set game-specific variables

GAME_ID='graveyard-keeper'
GAME_NAME='Graveyard Keeper'

UNITY3D_NAME='Graveyard Keeper'

ARCHIVE_BASE_1='graveyard_keeper_1_405_55214.sh'
ARCHIVE_BASE_1_MD5='6d5461b5f7571dd5bed0561d26f189b3'
ARCHIVE_BASE_1_TYPE='mojosetup'
ARCHIVE_BASE_1_SIZE='1800000'
ARCHIVE_BASE_1_VERSION='1.405-gog55214'
ARCHIVE_BASE_1_URL='https://www.gog.com/game/graveyard_keeper'

ARCHIVE_BASE_0='graveyard_keeper_1_402_51180.sh'
ARCHIVE_BASE_0_MD5='4095c374cade58a5ce4f6a80377cbcb7'
ARCHIVE_BASE_0_TYPE='mojosetup'
ARCHIVE_BASE_0_SIZE='1800000'
ARCHIVE_BASE_0_VERSION='1.402-gog51180'

ARCHIVE_BASE_MULTIARCH_9='graveyard_keeper_1_310_43140.sh'
ARCHIVE_BASE_MULTIARCH_9_MD5='f802e798769c343d2650d528c5fec77b'
ARCHIVE_BASE_MULTIARCH_9_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_9_SIZE='1700000'
ARCHIVE_BASE_MULTIARCH_9_VERSION='1.310-gog43140'

ARCHIVE_BASE_MULTIARCH_8='graveyard_keeper_1_309_42922.sh'
ARCHIVE_BASE_MULTIARCH_8_MD5='1100a2132d43e87a667d77a24c0b1f2f'
ARCHIVE_BASE_MULTIARCH_8_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_8_SIZE='1700000'
ARCHIVE_BASE_MULTIARCH_8_VERSION='1.309-gog42922'

ARCHIVE_BASE_MULTIARCH_7='graveyard_keeper_english_1_304_42468.sh'
ARCHIVE_BASE_MULTIARCH_7_MD5='0453a408697972de296a3d03de079c9a'
ARCHIVE_BASE_MULTIARCH_7_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_7_SIZE='1700000'
ARCHIVE_BASE_MULTIARCH_7_VERSION='1.304-gog42468'

ARCHIVE_BASE_MULTIARCH_6='graveyard_keeper_english_1_302_42323.sh'
ARCHIVE_BASE_MULTIARCH_6_MD5='029e1877be8d6dfae3ee2a880e213654'
ARCHIVE_BASE_MULTIARCH_6_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_6_SIZE='1700000'
ARCHIVE_BASE_MULTIARCH_6_VERSION='1.302-gog42323'

ARCHIVE_BASE_MULTIARCH_5='graveyard_keeper_1_206_35585.sh'
ARCHIVE_BASE_MULTIARCH_5_MD5='1312adee331b57bbf1ab97177c73d22c'
ARCHIVE_BASE_MULTIARCH_5_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_5_SIZE='1500000'
ARCHIVE_BASE_MULTIARCH_5_VERSION='1.206-gog35585'

ARCHIVE_BASE_MULTIARCH_4='graveyard_keeper_1_205_33760.sh'
ARCHIVE_BASE_MULTIARCH_4_MD5='adc36af20375c66709c907ff4bf61c62'
ARCHIVE_BASE_MULTIARCH_4_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_4_SIZE='1500000'
ARCHIVE_BASE_MULTIARCH_4_VERSION='1.205-gog33760'

ARCHIVE_BASE_MULTIARCH_3='graveyard_keeper_1_200_33444.sh'
ARCHIVE_BASE_MULTIARCH_3_MD5='b3ad034826ce31fa26214f64ac2dcf42'
ARCHIVE_BASE_MULTIARCH_3_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_3_SIZE='1500000'
ARCHIVE_BASE_MULTIARCH_3_VERSION='1.200-gog33444'

ARCHIVE_BASE_MULTIARCH_2='graveyard_keeper_1_124v2_30010.sh'
ARCHIVE_BASE_MULTIARCH_2_MD5='7d231af29281dcf9188508487dc2cbf4'
ARCHIVE_BASE_MULTIARCH_2_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_2_SIZE='920000'
ARCHIVE_BASE_MULTIARCH_2_VERSION='1.124.2-gog30010'

ARCHIVE_BASE_MULTIARCH_1='graveyard_keeper_1_123_29391.sh'
ARCHIVE_BASE_MULTIARCH_1_MD5='409540bb23b6c26ad42fd85d9f5440ec'
ARCHIVE_BASE_MULTIARCH_1_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_1_SIZE='940000'
ARCHIVE_BASE_MULTIARCH_1_VERSION='1.123-gog29391'

ARCHIVE_BASE_MULTIARCH_0='graveyard_keeper_1_122_25858.sh'
ARCHIVE_BASE_MULTIARCH_0_MD5='ad75b8ed2c4b74a763849918da672f5b'
ARCHIVE_BASE_MULTIARCH_0_TYPE='mojosetup'
ARCHIVE_BASE_MULTIARCH_0_SIZE='920000'
ARCHIVE_BASE_MULTIARCH_0_VERSION='1.122-gog25858'

CONTENT_PATH_DEFAULT='data/noarch/game'
CONTENT_GAME_BIN_FILES="
${UNITY3D_NAME}.x86_64
${UNITY3D_NAME}_Data/MonoBleedingEdge
${UNITY3D_NAME}_Data/Plugins
UnityPlayer.so"
CONTENT_GAME_DATA_FILES="
${UNITY3D_NAME}_Data"

PACKAGES_LIST='PKG_BIN PKG_DATA'

PKG_DATA_ID="${GAME_ID}-data"
PKG_DATA_DESCRIPTION='data'

PKG_BIN_ARCH='64'
PKG_BIN_DEPS="$PKG_DATA_ID"
PKG_BIN_DEPENDENCIES_LIBRARIES='
ld-linux-x86-64.so.2
libc.so.6
libdl.so.2
libgcc_s.so.1
libm.so.6
libpthread.so.0
librt.so.1
libz.so.1'

# Keep compatibility with old multiarch archives

CONTENT_GAME_BIN32_FILES="
${UNITY3D_NAME}.x86
${UNITY3D_NAME}_Data/Mono/x86
${UNITY3D_NAME}_Data/MonoBleedingEdge/x86
${UNITY3D_NAME}_Data/Plugins/x86"
CONTENT_GAME_BIN64_FILES="
${UNITY3D_NAME}.x86_64
${UNITY3D_NAME}_Data/Mono/x86_64
${UNITY3D_NAME}_Data/MonoBleedingEdge/x86_64
${UNITY3D_NAME}_Data/Plugins/x86_64"

PACKAGES_LIST_MULTIARCH='PKG_BIN32 PKG_BIN64 PKG_DATA'

PKG_BIN32_ARCH='32'
PKG_BIN32_DEPS="$PKG_DATA_ID"
PKG_BIN32_DEPENDENCIES_LIBRARIES='
libc.so.6
libstdc++.so.6
libgtk-x11-2.0.so.0
libGL.so.1
libudev.so.1
libgdk_pixbuf-2.0.so.0
libgobject-2.0.so.0
libglib-2.0.so.0'

PKG_BIN64_ARCH='64'
PKG_BIN64_DEPS="$PKG_BIN32_DEPS"
PKG_BIN64_DEPENDENCIES_LIBRARIES="$PKG_BIN32_DEPENDENCIES_LIBRARIES"

# Load common functions

target_version='2.19'

PLAYIT_LIB_PATHS="
$PWD
${XDG_DATA_HOME:="${HOME}/.local/share"}/play.it
/usr/local/share/games/play.it
/usr/local/share/play.it
/usr/share/games/play.it
/usr/share/play.it"

if [ -z "$PLAYIT_LIB2" ]; then
	for playit_lib_path in $PLAYIT_LIB_PATHS; do
		if [ -e "${playit_lib_path}/libplayit2.sh" ]; then
			PLAYIT_LIB2="${playit_lib_path}/libplayit2.sh"
			break
		fi
	done
fi
if [ -z "$PLAYIT_LIB2" ]; then
	printf '\n\033[1;31mError:\033[0m\n'
	printf 'libplayit2.sh not found.\n'
	exit 1
fi
. "$PLAYIT_LIB2"

# Extract game data

archive_extraction 'SOURCE_ARCHIVE'

# Include game icon

PKG='PKG_DATA'
icons_inclusion

# Include game data

content_inclusion_default

# Delete temporary files

rm --recursive "${PLAYIT_WORKDIR}/gamedata"

# Write launchers

for PKG in \
	'PKG_BIN' \
	'PKG_BIN32' \
	'PKG_BIN64'
do
	if packages_get_list | grep --quiet --fixed-strings --word-regexp "$PKG"; then
		launchers_write
	fi
done

# Build package

write_metadata
build_pkg

# Print instructions

print_instructions

# Clean up

rm --recursive "$PLAYIT_WORKDIR"

exit 0
